/*---------------------------------------------------------------------------
	
	File:
		stars.h
	
	Abstract:
		Starry background code (faked)

	Revisions:
		04-Jun-97 EAM Created

	Copyright (C) 1997 Edward Massey

	Credits to Joe Massey for starry background algorithm.

---------------------------------------------------------------------------*/

#ifndef _STARS_H_
#define _STARS_H_

struct STARS
{
	int m_fEnable;
	int m_cStars;
	int m_nScrollPos;
	int m_nScrollRate;
	int m_nBlink;

	struct STAR
	{
		int x, y, c;
	};
	
	STAR m_rgStars[256];

	STARS()
	{
		m_fEnable = 1;
		m_nScrollRate = 0;
		m_cStars = 0;
	}

	void Init(int x = 0, int cx = 256, int y = 0, int cy = 256, int cClr = 32, int cStars = 256)
	{
		_ASSERT(cStars <= DIM(m_rgStars));
		
		for (m_cStars = 0; m_cStars < cStars; m_cStars++)
		{
			m_rgStars[m_cStars].x = x + rand() % cx;
			m_rgStars[m_cStars].y = y + rand() % cy;
			m_rgStars[m_cStars].c = rand() % cClr;
		}
	}

	void Exec()
	{
		m_nScrollPos += m_nScrollRate;
		m_nBlink += 4;
	}

	void Draw(LPBYTE rgbBuffer, LONG lPitch)
	{
		if (m_fEnable)
		{
			for (int i = 0; i < m_cStars; i++)
			{
				int x, y;

				x = m_rgStars[i].x;
				y = (m_rgStars[i].y + m_nScrollPos / 2) % 256;

				if (((m_nBlink + i) % 256) < 128)
					rgbBuffer[lPitch * y + x] = m_rgStars[i].c;
			}
		}
	}
};

#endif // _STARS_H_

