/*---------------------------------------------------------------------------

	File:
		magexdrv.h

	Abstract:
		MageX game driver declarations.

	Revisions:
		31-Jan-97 EAM Created

---------------------------------------------------------------------------*/

#ifndef _MAGEXDRV_H_
#define _MAGEXDRV_H_

#include "graphics.h"
#include "../main/script.h"

//
//  Interface the shell uses...  assumes the game uses a single
//  palette and a single-sized buffer
//

struct GAME_LOAD_INFO
{
	SIZE sizBuffer;
	RECT rcDisplay;
	PALETTEENTRY *ppe;
	UINT cpe;
	LPTSTR pszMsg;
	UINT cchMsgMax;
	LPVOID pvContext;

/*
	int     nCpuSpeed;
	int     nFrameRate;
*/

	SCRIPT_GAME script_game;
	IMAGE *rgpImage[16];
};

// TODO:  pass game save/restore into to term/init

struct MAGEX_DRIVER_DESCRIPTOR
{
	LPCTSTR pszTitle;
	LPVOID  pvContext;

	HRESULT (*pfnLoad)(GAME_LOAD_INFO &gli);
	int (*Exec)(/*DWORD dwFlags*/); // dwFlags & MDEF_NOEXECAUDIO
	void (*pfnDrawFrame)(LPBYTE rgbBuffer, LONG lPitch);
	void (*pfnUpdateSound)(LPBYTE rgbBuffer, LONG cbBuffer);
	void (*pfnTerm)();

	HRESULT (*pfnGetGraphicInfo)(int iImage, IMAGE &img);
	HRESULT (*pfnCmd)(HWND hwndOwner, UINT nCmdId);
	HRESULT (*pfnCmdUpdate)(UINT nCmdId, UINT &nState);
};

typedef MAGEX_DRIVER_DESCRIPTOR GAME_DESCRIPTOR;

interface IMageDrv : IUnknown
{
	virtual void Execute() = 0;
	virtual void DrawFrame(LPBYTE rgbBuffer, LONG lPitch) = 0;
	virtual void UpdateSound(LPBYTE rgbBuffer, LONG cSamples) = 0;
};

struct MAGEX_DRIVER_DESCRIPTOR2
{
	LPCTSTR pszTitle;
	LPVOID  pvContext;
	HRESULT (*pfnCreate)(GAME_LOAD_INFO &gli);
};

struct DRIVER_DESCRIPTOR
{
	LPCTSTR szName;
	GAME_DESCRIPTOR *pgmd;
};

#endif // _MAGEXDRV_H_

