/*---------------------------------------------------------------------------
	
	File:
		registry.cpp
	
	Abstract:
		Registry database functions for MageX..

	Revisions:
		31-May-97 EAM Created

	Copyright (C) 1997 Edward Massey

---------------------------------------------------------------------------*/

#include "pch.h"
#include "winreg.h"

static HKEY _hkeyLocalMachine;

static const TCHAR _szRegPath[] = "Software\\Massey\\MageX\\CurrentVersion";

HRESULT RegInit()
{
	DWORD dwDisposition;
	
	LONG l = RegCreateKeyEx(HKEY_LOCAL_MACHINE, _szRegPath,
		0, NULL, 0, KEY_ALL_ACCESS, NULL, &_hkeyLocalMachine, &dwDisposition);

	return S_OK;
}

HRESULT RegTerm()
{
	if (_hkeyLocalMachine!= NULL)
		RegCloseKey(_hkeyLocalMachine);

	return S_OK;
}

HRESULT RegGetValue(LPCTSTR pszName, LPTSTR pszVal, int cchValMax)
{
	DWORD dwType;
	DWORD cbData = sizeof(pszVal[0]) * cchValMax;

	return (RegQueryValueEx(_hkeyLocalMachine, pszName, NULL, &dwType,
		(LPBYTE)pszVal, &cbData) == ERROR_SUCCESS && dwType == REG_SZ);
}

HRESULT RegGetValue(LPCTSTR pszName, DWORD &dwValue)
{
	DWORD dwType;
	DWORD cbData = sizeof(dwValue);

	return (RegQueryValueEx(_hkeyLocalMachine, pszName, NULL, &dwType,
		(LPBYTE)&dwValue, &cbData) == ERROR_SUCCESS && dwType == REG_DWORD);
}

/*
template <class T> BOOL RegGetStruct(HKEY hkey, LPCTSTR pszName, T &t)
{
	DWORD dwType;
	DWORD cbData = sizeof(t);

	return (RegQueryValueEx(hkey, pszName, NULL, &dwType,
		(LPBYTE)&t, &cbData) == ERROR_SUCCESS && dwType == REG_BINARY);
}

inline BOOL RegGetDword(HKEY hkey, LPCTSTR pszName, DWORD &dwItem)
{
	DWORD dwType;
	DWORD cbData = sizeof(dwItem);

	return (RegQueryValueEx(hkey, pszName, NULL, &dwType,
		(LPBYTE)&dwItem, &cbData) == ERROR_SUCCESS && dwType == REG_DWORD);
}

inline BOOL RegGetSz(HKEY hkey, LPCTSTR pszName, LPTSTR pszVal, int cchValMax)
{
	DWORD dwType;
	DWORD cbData = sizeof(pszVal[0]) * cchValMax;

	return (RegQueryValueEx(hkey, pszName, NULL, &dwType,
		(LPBYTE)pszVal, &cbData) == ERROR_SUCCESS && dwType == REG_SZ);
}

template <class T> BOOL RegPutStruct(HKEY hkey, LPCTSTR pszName, const T &t)
{
	return (RegSetValueEx(hkey, pszName, 0, REG_BINARY, 
		(LPBYTE)&t, sizeof(t)) == ERROR_SUCCESS);
}

inline BOOL RegPutDword(HKEY hkey, LPCTSTR pszName, DWORD dwItem)
{
	return (RegSetValueEx(hkey, pszName, 0, REG_DWORD,
		(LPBYTE)&dwItem, sizeof(dwItem)) == ERROR_SUCCESS);
}

inline BOOL RegPutSz(HKEY hkey, LPCTSTR pszName, LPCTSTR pszVal)
{
	DWORD cbVal = lstrlen(pszVal) * sizeof(pszVal[0]);

	return (RegSetValueEx(hkey, pszName, 0, REG_SZ,
		(LPBYTE)pszVal, cbVal) == ERROR_SUCCESS);
}

*/

