/*---------------------------------------------------------------------------

	File:
	
	Abstract:

	Revisions:

	Copyright (C) 1997 Edward Massey

---------------------------------------------------------------------------*/

#ifndef _SCRIPT_H_
#define _SCRIPT_H_

#define ROMSET_MAX  32

struct SCRIPT_ROMSET
{
	TCHAR szName[32];

	struct ENTRY
	{
		TCHAR szFilename[32];
		DWORD dwLoadLength;
		DWORD dwLoadOffset;
		DWORD dwFileOffset;
	};

	int cEntries;
	ENTRY rgEntries[32];
};

struct SCRIPT_GAME
{
	TCHAR szName[32];
	TCHAR szTitle[32];
	TCHAR szPath[32];
	TCHAR szDriver[32];
	int cRomsets;
	SCRIPT_ROMSET rgRomsets[ROMSET_MAX];
};

HRESULT ScriptInit(LPCTSTR pszFilename);
HRESULT ScriptTerm();
HRESULT ScriptFindGame(LPCTSTR pszName, SCRIPT_GAME &game);
HRESULT ScriptLoadRoms(const SCRIPT_GAME &game, LPCTSTR pszRomsetName, LPBYTE rgbBase);
HRESULT ScriptLoadRoms(const SCRIPT_ROMSET &romset, LPCTSTR pszPath, LPBYTE rgbBase);
HRESULT ScriptAddGame(const SCRIPT_GAME &game);

#endif // _SCRIPT_H_

