/*---------------------------------------------------------------------------
	
	File:
		wndmgr.h
	
	Abstract:
		Public interface for window manager services.

	Revisions:
		Jan-21-96 EAM Created
		
---------------------------------------------------------------------------*/

#ifndef _WNDMGR_H_
#define _WNDMGR_H_

//
//  Window interface (called by library)
//

interface IWindow : IUnknown
{
	virtual void UpdateUI(int nCmdId, UINT &nState) = 0;
	virtual BOOL PreTranslateMsg(MSG &msg) = 0;
	virtual LRESULT OnMessage(MSG &msg) = 0;
};

LPCTSTR WndRegisterWindowClass(LPCTSTR pszName, UINT style);

HWND WndCreateWindow(DWORD dwExStyle, LPCTSTR pszClassName,
	LPCTSTR pszWindowName, DWORD dwStyle, int x, int y, int cx, int cy,
	HWND hwndOwner, HMENU hmenu, IWindow *pwnd);

#endif

