/*---------------------------------------------------------------------------

	File:
		newz80.cpp

	Abstract:
		Internal declarations for Zilog Z80 emulator.

	Revisions:
		18-Apr-97 EAM Created

	Copyright (C) 1997 Edward Massey

---------------------------------------------------------------------------*/

#include "pch.h"
#include "execz80i.h"

void InitTables();

extern "C" void TRACE(LPCTSTR pszFormat, ...)
{
#ifdef _DEBUG
	va_list marker;
	va_start(marker, pszFormat);
	TCHAR szBuf[128];
	_vsnprintf(szBuf, 128, pszFormat, marker);

	OutputDebugString(szBuf);
	return;

	static FILE *pfTrace;

	if (pfTrace == NULL)
		pfTrace = fopen("z80debug.txt", "w");

	if (pfTrace != NULL)
	{
		fputs(szBuf, pfTrace);
		fflush(pfTrace);
	}
#endif
}

extern "C" void TRACE_M(LPCTSTR pszFormat, ...)
{
	va_list marker;
	va_start(marker, pszFormat);
	TCHAR szBuf[128];
	_vsnprintf(szBuf, 128, pszFormat, marker);

	OutputDebugString(szBuf);
	return;

	static FILE *pfTrace;

	if (pfTrace == NULL)
		pfTrace = fopen("z80debugm.txt", "w");

	if (pfTrace != NULL)
	{
		fputs(szBuf, pfTrace);
		fflush(pfTrace);
	}
}

BOOL WINAPI DllMain(HANDLE hInst, ULONG u, LPVOID)
{
	switch (u)
	{
		case DLL_PROCESS_ATTACH:
			InitTables();
			break;
	}

	return TRUE;
}

#ifdef _DEBUG
extern "C" int _rgcIns[] = { -1, -1 };
#endif

EXECZ80_API HRESULT EclCreateZ80(EXECZ80_CREATE &cs, IExecZ80 *&pExec)
{
#ifdef _DEBUG
	LPCTSTR pszCmdLine = GetCommandLine();

	TCHAR szProgram[256];
	
	sscanf(pszCmdLine, "%s dump:%i,%i", szProgram, &_rgcIns[0], &_rgcIns[1]);
#endif

	return CExecZ80::Create(cs, pExec);
}

